--upvalues
local _ = _
local GetNumGroupMembers = GetNumGroupMembers
local GetNumSubgroupMembers = GetNumSubgroupMembers
local GetRaidRosterInfo = GetRaidRosterInfo
local UnitInRaid = UnitInRaid
local UnitName = UnitName
local UnitBuff = UnitBuff
local table = table
local print = print
local select = select
local GetInstanceInfo = GetInstanceInfo

function FeastCheck_OnLoad()
	SlashCmdList["FeastCheck"]=FeastCheck_Command
	SLASH_FeastCheck1="/FeastCheck"
	SLASH_FeastCheck2="/fck"
end

function FeastCheck_Command()
	local num
	if UnitInRaid("player") then
		num = GetNumGroupMembers()
	else
		num = GetNumSubgroupMembers()
	end
	if not num or num == 0 then return end
	local count, name, group, notfed = 0, nil, nil, {}
	for i = 1, num do
		if UnitInRaid("player") then
			name, _, group = GetRaidRosterInfo(i)
		else
			name = UnitName("party"..i)
		end
		local diff = select(3,GetInstanceInfo())
		if not UnitBuff(name,"Well Fed") and (((diff == 3 or diff == 5) and ((UnitInRaid("player") and group < 3) or not UnitInRaid("player"))) or
		((diff == 4 or diff == 6 or diff == 7) and ((UnitInRaid("player") and group < 6) or not UnitInRaid("player"))) ) then
			table.insert(notfed, name)
			count = count + 1
		end
	end
	if not UnitInRaid("player") then
		name = UnitName("player")
		if not UnitBuff(name,"Well Fed") then
			table.insert(notfed, name)
			count = count + 1
		end
	end
	if notfed and count then
		notfed = table.concat(notfed, ", ")
		if count ~= 0 then print(notfed) end
		print(count .. " without any food!")
	else
		print("Everyone has food buff")
	end
end

